/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.CorePackage;

import edu.kit.ipd.descartes.identifier.IdentifierPackage;

import edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement;
import edu.kit.ipd.descartes.mm.adaptation.Action;
import edu.kit.ipd.descartes.mm.adaptation.ActionReference;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationFactory;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationScope;
import edu.kit.ipd.descartes.mm.adaptation.BranchAction;
import edu.kit.ipd.descartes.mm.adaptation.Event;
import edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration;
import edu.kit.ipd.descartes.mm.adaptation.LoopAction;
import edu.kit.ipd.descartes.mm.adaptation.Objective;
import edu.kit.ipd.descartes.mm.adaptation.OverallGoal;
import edu.kit.ipd.descartes.mm.adaptation.Parameter;
import edu.kit.ipd.descartes.mm.adaptation.RelationalOperator;
import edu.kit.ipd.descartes.mm.adaptation.Specification;
import edu.kit.ipd.descartes.mm.adaptation.StartAction;
import edu.kit.ipd.descartes.mm.adaptation.StopAction;
import edu.kit.ipd.descartes.mm.adaptation.Strategy;
import edu.kit.ipd.descartes.mm.adaptation.Tactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightedMetric;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage;

import edu.kit.ipd.descartes.perfdatarepo.PerfdatarepoPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationPackageImpl extends EPackageImpl implements AdaptationPackage {
    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass adaptationProcessEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass overallGoalEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass strategyEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass eventEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass objectiveEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass specificationEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass weightingFunctionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass weightedMetricEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass weightedTacticEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass tacticEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass abstractControlFlowElementEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass startActionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass stopActionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass loopActionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass branchActionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass actionReferenceEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass adaptationPlanEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass actionEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass adaptationActionOperationEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass parameterEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EClass importDeclarationEClass = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum adaptationScopeEEnum = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum adaptationDirectionEEnum = null;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum relationalOperatorEEnum = null;

    /**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
    private AdaptationPackageImpl() {
		super(eNS_URI, AdaptationFactory.eINSTANCE);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private static boolean isInited = false;

    /**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link AdaptationPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
    public static AdaptationPackage init() {
		if (isInited) return (AdaptationPackage)EPackage.Registry.INSTANCE.getEPackage(AdaptationPackage.eNS_URI);

		// Obtain or create and register package
		AdaptationPackageImpl theAdaptationPackage = (AdaptationPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof AdaptationPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new AdaptationPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		AdaptationpointsPackage.eINSTANCE.eClass();
		PerfdatarepoPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theAdaptationPackage.createPackageContents();

		// Initialize created meta-data
		theAdaptationPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theAdaptationPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(AdaptationPackage.eNS_URI, theAdaptationPackage);
		return theAdaptationPackage;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAdaptationProcess() {
		return adaptationProcessEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_Tactics() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_Actions() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_Strategies() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_Parameters() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_Goal() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationProcess_ImportDeclaration() {
		return (EReference)adaptationProcessEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getOverallGoal() {
		return overallGoalEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getOverallGoal_Objectives() {
		return (EReference)overallGoalEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getOverallGoal_Description() {
		return (EAttribute)overallGoalEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getStrategy() {
		return strategyEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getStrategy_Objective() {
		return (EReference)strategyEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getStrategy_TriggeringEvents() {
		return (EReference)strategyEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getStrategy_Tactics() {
		return (EReference)strategyEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getStrategy_WeightingFunction() {
		return (EReference)strategyEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getEvent() {
		return eventEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getEvent_Triggers() {
		return (EReference)eventEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getObjective() {
		return objectiveEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getObjective_Specifications() {
		return (EReference)objectiveEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getSpecification() {
		return specificationEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getSpecification_MetricType() {
		return (EReference)specificationEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getSpecification_Value() {
		return (EAttribute)specificationEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getSpecification_RelationalOperator() {
		return (EAttribute)specificationEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getWeightingFunction() {
		return weightingFunctionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getWeightingFunction_WeightedMetrics() {
		return (EReference)weightingFunctionEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWeightingFunction_WeightingFunctionImplementation() {
		return (EAttribute)weightingFunctionEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getWeightedMetric() {
		return weightedMetricEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWeightedMetric_Weight() {
		return (EAttribute)weightedMetricEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getWeightedMetric_MetricType() {
		return (EReference)weightedMetricEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getWeightedTactic() {
		return weightedTacticEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getWeightedTactic_UsedTactic() {
		return (EReference)weightedTacticEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWeightedTactic_CurrentWeight() {
		return (EAttribute)weightedTacticEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWeightedTactic_DefaultWeight() {
		return (EAttribute)weightedTacticEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getWeightedTactic_LastImpact() {
		return (EReference)weightedTacticEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getWeightedTactic_ParentStrategy() {
		return (EReference)weightedTacticEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getTactic() {
		return tacticEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getTactic_ImplementedPlan() {
		return (EReference)tacticEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getTactic_InputParams() {
		return (EReference)tacticEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getTactic_OutputParam() {
		return (EReference)tacticEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAbstractControlFlowElement() {
		return abstractControlFlowElementEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAbstractControlFlowElement_Predecessor() {
		return (EReference)abstractControlFlowElementEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAbstractControlFlowElement_Successor() {
		return (EReference)abstractControlFlowElementEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getStartAction() {
		return startActionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getStopAction() {
		return stopActionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getLoopAction() {
		return loopActionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getLoopAction_Counter() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getLoopAction_Body() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getBranchAction() {
		return branchActionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getBranchAction_Context() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getBranchAction_Condition() {
		return (EAttribute)branchActionEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getBranchAction_ConditionTrueBranch() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getBranchAction_ConditionFalseBranch() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getActionReference() {
		return actionReferenceEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getActionReference_RefersTo() {
		return (EReference)actionReferenceEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAdaptationPlan() {
		return adaptationPlanEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAdaptationPlan_Steps() {
		return (EReference)adaptationPlanEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAction() {
		return actionEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAction_OutputParam() {
		return (EReference)actionEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAction_InputParams() {
		return (EReference)actionEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAction_ReferredAdaptationPoint() {
		return (EReference)actionEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getAction_AdaptationActionOperation() {
		return (EReference)actionEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAdaptationActionOperation() {
		return adaptationActionOperationEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getAdaptationActionOperation_AdaptationOperationScope() {
		return (EAttribute)adaptationActionOperationEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getAdaptationActionOperation_AdaptationOperationDirection() {
		return (EAttribute)adaptationActionOperationEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getParameter() {
		return parameterEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getParameter_Name() {
		return (EAttribute)parameterEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getParameter_Type() {
		return (EAttribute)parameterEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getParameter_Value() {
		return (EAttribute)parameterEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getImportDeclaration() {
		return importDeclarationEClass;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getImportDeclaration_ImportURI() {
		return (EAttribute)importDeclarationEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getAdaptationScope() {
		return adaptationScopeEEnum;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getAdaptationDirection() {
		return adaptationDirectionEEnum;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getRelationalOperator() {
		return relationalOperatorEEnum;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationFactory getAdaptationFactory() {
		return (AdaptationFactory)getEFactoryInstance();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isCreated = false;

    /**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		adaptationProcessEClass = createEClass(ADAPTATION_PROCESS);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__TACTICS);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__ACTIONS);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__STRATEGIES);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__PARAMETERS);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__GOAL);
		createEReference(adaptationProcessEClass, ADAPTATION_PROCESS__IMPORT_DECLARATION);

		overallGoalEClass = createEClass(OVERALL_GOAL);
		createEReference(overallGoalEClass, OVERALL_GOAL__OBJECTIVES);
		createEAttribute(overallGoalEClass, OVERALL_GOAL__DESCRIPTION);

		strategyEClass = createEClass(STRATEGY);
		createEReference(strategyEClass, STRATEGY__OBJECTIVE);
		createEReference(strategyEClass, STRATEGY__TRIGGERING_EVENTS);
		createEReference(strategyEClass, STRATEGY__TACTICS);
		createEReference(strategyEClass, STRATEGY__WEIGHTING_FUNCTION);

		eventEClass = createEClass(EVENT);
		createEReference(eventEClass, EVENT__TRIGGERS);

		objectiveEClass = createEClass(OBJECTIVE);
		createEReference(objectiveEClass, OBJECTIVE__SPECIFICATIONS);

		specificationEClass = createEClass(SPECIFICATION);
		createEReference(specificationEClass, SPECIFICATION__METRIC_TYPE);
		createEAttribute(specificationEClass, SPECIFICATION__VALUE);
		createEAttribute(specificationEClass, SPECIFICATION__RELATIONAL_OPERATOR);

		weightingFunctionEClass = createEClass(WEIGHTING_FUNCTION);
		createEReference(weightingFunctionEClass, WEIGHTING_FUNCTION__WEIGHTED_METRICS);
		createEAttribute(weightingFunctionEClass, WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION);

		weightedMetricEClass = createEClass(WEIGHTED_METRIC);
		createEAttribute(weightedMetricEClass, WEIGHTED_METRIC__WEIGHT);
		createEReference(weightedMetricEClass, WEIGHTED_METRIC__METRIC_TYPE);

		weightedTacticEClass = createEClass(WEIGHTED_TACTIC);
		createEReference(weightedTacticEClass, WEIGHTED_TACTIC__USED_TACTIC);
		createEAttribute(weightedTacticEClass, WEIGHTED_TACTIC__CURRENT_WEIGHT);
		createEAttribute(weightedTacticEClass, WEIGHTED_TACTIC__DEFAULT_WEIGHT);
		createEReference(weightedTacticEClass, WEIGHTED_TACTIC__LAST_IMPACT);
		createEReference(weightedTacticEClass, WEIGHTED_TACTIC__PARENT_STRATEGY);

		tacticEClass = createEClass(TACTIC);
		createEReference(tacticEClass, TACTIC__IMPLEMENTED_PLAN);
		createEReference(tacticEClass, TACTIC__INPUT_PARAMS);
		createEReference(tacticEClass, TACTIC__OUTPUT_PARAM);

		abstractControlFlowElementEClass = createEClass(ABSTRACT_CONTROL_FLOW_ELEMENT);
		createEReference(abstractControlFlowElementEClass, ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR);
		createEReference(abstractControlFlowElementEClass, ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR);

		startActionEClass = createEClass(START_ACTION);

		stopActionEClass = createEClass(STOP_ACTION);

		loopActionEClass = createEClass(LOOP_ACTION);
		createEReference(loopActionEClass, LOOP_ACTION__COUNTER);
		createEReference(loopActionEClass, LOOP_ACTION__BODY);

		branchActionEClass = createEClass(BRANCH_ACTION);
		createEReference(branchActionEClass, BRANCH_ACTION__CONTEXT);
		createEAttribute(branchActionEClass, BRANCH_ACTION__CONDITION);
		createEReference(branchActionEClass, BRANCH_ACTION__CONDITION_TRUE_BRANCH);
		createEReference(branchActionEClass, BRANCH_ACTION__CONDITION_FALSE_BRANCH);

		actionReferenceEClass = createEClass(ACTION_REFERENCE);
		createEReference(actionReferenceEClass, ACTION_REFERENCE__REFERS_TO);

		adaptationPlanEClass = createEClass(ADAPTATION_PLAN);
		createEReference(adaptationPlanEClass, ADAPTATION_PLAN__STEPS);

		actionEClass = createEClass(ACTION);
		createEReference(actionEClass, ACTION__OUTPUT_PARAM);
		createEReference(actionEClass, ACTION__INPUT_PARAMS);
		createEReference(actionEClass, ACTION__REFERRED_ADAPTATION_POINT);
		createEReference(actionEClass, ACTION__ADAPTATION_ACTION_OPERATION);

		adaptationActionOperationEClass = createEClass(ADAPTATION_ACTION_OPERATION);
		createEAttribute(adaptationActionOperationEClass, ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_SCOPE);
		createEAttribute(adaptationActionOperationEClass, ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_DIRECTION);

		parameterEClass = createEClass(PARAMETER);
		createEAttribute(parameterEClass, PARAMETER__NAME);
		createEAttribute(parameterEClass, PARAMETER__TYPE);
		createEAttribute(parameterEClass, PARAMETER__VALUE);

		importDeclarationEClass = createEClass(IMPORT_DECLARATION);
		createEAttribute(importDeclarationEClass, IMPORT_DECLARATION__IMPORT_URI);

		// Create enums
		adaptationScopeEEnum = createEEnum(ADAPTATION_SCOPE);
		adaptationDirectionEEnum = createEEnum(ADAPTATION_DIRECTION);
		relationalOperatorEEnum = createEEnum(RELATIONAL_OPERATOR);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isInitialized = false;

    /**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		PerfdatarepoPackage thePerfdatarepoPackage = (PerfdatarepoPackage)EPackage.Registry.INSTANCE.getEPackage(PerfdatarepoPackage.eNS_URI);
		IdentifierPackage theIdentifierPackage = (IdentifierPackage)EPackage.Registry.INSTANCE.getEPackage(IdentifierPackage.eNS_URI);
		AdaptationpointsPackage theAdaptationpointsPackage = (AdaptationpointsPackage)EPackage.Registry.INSTANCE.getEPackage(AdaptationpointsPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		adaptationProcessEClass.getESuperTypes().add(theCorePackage.getEntity());
		strategyEClass.getESuperTypes().add(theCorePackage.getEntity());
		eventEClass.getESuperTypes().add(theCorePackage.getEntity());
		objectiveEClass.getESuperTypes().add(theCorePackage.getEntity());
		weightingFunctionEClass.getESuperTypes().add(theCorePackage.getEntity());
		weightedMetricEClass.getESuperTypes().add(theCorePackage.getEntity());
		weightedTacticEClass.getESuperTypes().add(theCorePackage.getEntity());
		tacticEClass.getESuperTypes().add(theCorePackage.getEntity());
		abstractControlFlowElementEClass.getESuperTypes().add(theIdentifierPackage.getIdentifier());
		startActionEClass.getESuperTypes().add(this.getAbstractControlFlowElement());
		stopActionEClass.getESuperTypes().add(this.getAbstractControlFlowElement());
		loopActionEClass.getESuperTypes().add(this.getAbstractControlFlowElement());
		branchActionEClass.getESuperTypes().add(this.getAbstractControlFlowElement());
		actionReferenceEClass.getESuperTypes().add(this.getAbstractControlFlowElement());
		adaptationPlanEClass.getESuperTypes().add(theCorePackage.getEntity());
		actionEClass.getESuperTypes().add(theCorePackage.getEntity());

		// Initialize classes and features; add operations and parameters
		initEClass(adaptationProcessEClass, AdaptationProcess.class, "AdaptationProcess", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptationProcess_Tactics(), this.getTactic(), null, "tactics", null, 1, -1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAdaptationProcess_Actions(), this.getAction(), null, "actions", null, 1, -1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAdaptationProcess_Strategies(), this.getStrategy(), null, "strategies", null, 1, -1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAdaptationProcess_Parameters(), this.getParameter(), null, "parameters", null, 0, -1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAdaptationProcess_Goal(), this.getOverallGoal(), null, "goal", null, 1, 1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAdaptationProcess_ImportDeclaration(), this.getImportDeclaration(), null, "importDeclaration", null, 0, -1, AdaptationProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(overallGoalEClass, OverallGoal.class, "OverallGoal", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOverallGoal_Objectives(), this.getObjective(), null, "objectives", null, 1, -1, OverallGoal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getOverallGoal_Description(), ecorePackage.getEString(), "description", null, 1, 1, OverallGoal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(strategyEClass, Strategy.class, "Strategy", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStrategy_Objective(), this.getObjective(), null, "objective", null, 1, 1, Strategy.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStrategy_TriggeringEvents(), this.getEvent(), this.getEvent_Triggers(), "triggeringEvents", null, 1, 1, Strategy.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStrategy_Tactics(), this.getWeightedTactic(), this.getWeightedTactic_ParentStrategy(), "tactics", null, 1, -1, Strategy.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStrategy_WeightingFunction(), this.getWeightingFunction(), null, "weightingFunction", null, 1, 1, Strategy.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(eventEClass, Event.class, "Event", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEvent_Triggers(), this.getStrategy(), this.getStrategy_TriggeringEvents(), "triggers", null, 1, 1, Event.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(objectiveEClass, Objective.class, "Objective", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getObjective_Specifications(), this.getSpecification(), null, "specifications", null, 1, -1, Objective.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(specificationEClass, Specification.class, "Specification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSpecification_MetricType(), thePerfdatarepoPackage.getMetricType(), null, "metricType", null, 1, 1, Specification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getSpecification_Value(), ecorePackage.getEDouble(), "value", null, 1, 1, Specification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getSpecification_RelationalOperator(), this.getRelationalOperator(), "relationalOperator", null, 1, 1, Specification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(weightingFunctionEClass, WeightingFunction.class, "WeightingFunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWeightingFunction_WeightedMetrics(), this.getWeightedMetric(), null, "weightedMetrics", null, 1, -1, WeightingFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getWeightingFunction_WeightingFunctionImplementation(), ecorePackage.getEString(), "weightingFunctionImplementation", "", 1, 1, WeightingFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(weightedMetricEClass, WeightedMetric.class, "WeightedMetric", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getWeightedMetric_Weight(), ecorePackage.getEDouble(), "weight", null, 1, 1, WeightedMetric.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getWeightedMetric_MetricType(), thePerfdatarepoPackage.getMetricType(), null, "metricType", null, 1, 1, WeightedMetric.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(weightedTacticEClass, WeightedTactic.class, "WeightedTactic", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWeightedTactic_UsedTactic(), this.getTactic(), null, "usedTactic", null, 1, 1, WeightedTactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getWeightedTactic_CurrentWeight(), ecorePackage.getEDouble(), "currentWeight", null, 1, 1, WeightedTactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getWeightedTactic_DefaultWeight(), ecorePackage.getEDouble(), "defaultWeight", null, 1, 1, WeightedTactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getWeightedTactic_LastImpact(), thePerfdatarepoPackage.getImpact(), null, "lastImpact", null, 0, 1, WeightedTactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getWeightedTactic_ParentStrategy(), this.getStrategy(), this.getStrategy_Tactics(), "parentStrategy", null, 0, 1, WeightedTactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(tacticEClass, Tactic.class, "Tactic", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTactic_ImplementedPlan(), this.getAdaptationPlan(), null, "implementedPlan", null, 1, 1, Tactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getTactic_InputParams(), this.getParameter(), null, "inputParams", null, 0, -1, Tactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getTactic_OutputParam(), this.getParameter(), null, "outputParam", null, 0, 1, Tactic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(abstractControlFlowElementEClass, AbstractControlFlowElement.class, "AbstractControlFlowElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractControlFlowElement_Predecessor(), this.getAbstractControlFlowElement(), this.getAbstractControlFlowElement_Successor(), "predecessor", null, 0, 1, AbstractControlFlowElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAbstractControlFlowElement_Successor(), this.getAbstractControlFlowElement(), this.getAbstractControlFlowElement_Predecessor(), "successor", null, 0, 1, AbstractControlFlowElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(startActionEClass, StartAction.class, "StartAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(stopActionEClass, StopAction.class, "StopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(loopActionEClass, LoopAction.class, "LoopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopAction_Counter(), this.getParameter(), null, "counter", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getLoopAction_Body(), this.getAdaptationPlan(), null, "body", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(branchActionEClass, BranchAction.class, "BranchAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchAction_Context(), theCorePackage.getEntity(), null, "context", null, 0, 1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getBranchAction_Condition(), ecorePackage.getEString(), "condition", null, 0, 1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getBranchAction_ConditionTrueBranch(), this.getAdaptationPlan(), null, "conditionTrueBranch", null, 1, 1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getBranchAction_ConditionFalseBranch(), this.getAdaptationPlan(), null, "conditionFalseBranch", null, 1, 1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(actionReferenceEClass, ActionReference.class, "ActionReference", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActionReference_RefersTo(), this.getAction(), null, "refersTo", null, 1, 1, ActionReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(adaptationPlanEClass, AdaptationPlan.class, "AdaptationPlan", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptationPlan_Steps(), this.getAbstractControlFlowElement(), null, "steps", null, 0, -1, AdaptationPlan.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(actionEClass, Action.class, "Action", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAction_OutputParam(), this.getParameter(), null, "outputParam", null, 0, 1, Action.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAction_InputParams(), this.getParameter(), null, "inputParams", null, 0, -1, Action.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAction_ReferredAdaptationPoint(), theAdaptationpointsPackage.getAdaptationPoint(), null, "referredAdaptationPoint", null, 1, 1, Action.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAction_AdaptationActionOperation(), this.getAdaptationActionOperation(), null, "adaptationActionOperation", null, 1, 1, Action.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(adaptationActionOperationEClass, AdaptationActionOperation.class, "AdaptationActionOperation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptationActionOperation_AdaptationOperationScope(), this.getAdaptationScope(), "adaptationOperationScope", null, 1, 1, AdaptationActionOperation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getAdaptationActionOperation_AdaptationOperationDirection(), this.getAdaptationDirection(), "adaptationOperationDirection", null, 1, 1, AdaptationActionOperation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(parameterEClass, Parameter.class, "Parameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getParameter_Name(), ecorePackage.getEString(), "name", null, 1, 1, Parameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getParameter_Type(), ecorePackage.getEString(), "type", null, 1, 1, Parameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getParameter_Value(), ecorePackage.getEString(), "value", null, 1, 1, Parameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(importDeclarationEClass, ImportDeclaration.class, "ImportDeclaration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getImportDeclaration_ImportURI(), ecorePackage.getEString(), "importURI", null, 0, 1, ImportDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(adaptationScopeEEnum, AdaptationScope.class, "AdaptationScope");
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.NOT_SET);
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.THIS);
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.LEAST_UTILIZED_FIRST);
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.MOST_UTILIZED_FIRST);
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.RANDOM);
		addEEnumLiteral(adaptationScopeEEnum, AdaptationScope.ALL);

		initEEnum(adaptationDirectionEEnum, AdaptationDirection.class, "AdaptationDirection");
		addEEnumLiteral(adaptationDirectionEEnum, AdaptationDirection.NOT_SET);
		addEEnumLiteral(adaptationDirectionEEnum, AdaptationDirection.INCREASE);
		addEEnumLiteral(adaptationDirectionEEnum, AdaptationDirection.DECREASE);
		addEEnumLiteral(adaptationDirectionEEnum, AdaptationDirection.MIGRATE);

		initEEnum(relationalOperatorEEnum, RelationalOperator.class, "RelationalOperator");
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.EQUAL);
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.NOT_EQUAL);
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.GREATER);
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.GREATER_EQUAL);
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.LESS);
		addEEnumLiteral(relationalOperatorEEnum, RelationalOperator.LESS_EQUAL);

		// Create resource
		createResource(eNS_URI);
	}

} //AdaptationPackageImpl
