/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Influenced Variable Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getInfluencedVariable <em>Influenced Variable</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getControlFlowVariable <em>Control Flow Variable</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResourceDemand <em>Resource Demand</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResponseTime <em>Response Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getInfluencedVariableReference()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ExactlyOneVariableReferenced'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot ExactlyOneVariableReferenced='\n\t\t\tlet nonnullset : Set(ModelVariable) = Set{controlFlowVariable, resourceDemand, responseTime}->reject(mv|mv = null) \n\t\t\tin nonnullset->size() = 1'"
 * @generated
 */
public interface InfluencedVariableReference extends EObject {
	/**
	 * Returns the value of the '<em><b>Influenced Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Influenced Variable</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Influenced Variable</em>' reference.
	 * @see #setInfluencedVariable(ModelVariable)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getInfluencedVariableReference_InfluencedVariable()
	 * @model required="true" transient="true" volatile="true" derived="true"
	 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='\n\t\t\t\tlet nonnullset : Set(ModelVariable) = Set{controlFlowVariable, resourceDemand, responseTime}->reject(mv|mv = null) \n\t\t\t\tin nonnullset->any(true)'"
	 * @generated
	 */
	ModelVariable getInfluencedVariable();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getInfluencedVariable <em>Influenced Variable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Influenced Variable</em>' reference.
	 * @see #getInfluencedVariable()
	 * @generated
	 */
	void setInfluencedVariable(ModelVariable value);

	/**
	 * Returns the value of the '<em><b>Control Flow Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Control Flow Variable</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Control Flow Variable</em>' reference.
	 * @see #setControlFlowVariable(ControlFlowVariable)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getInfluencedVariableReference_ControlFlowVariable()
	 * @model
	 * @generated
	 */
	ControlFlowVariable getControlFlowVariable();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getControlFlowVariable <em>Control Flow Variable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Control Flow Variable</em>' reference.
	 * @see #getControlFlowVariable()
	 * @generated
	 */
	void setControlFlowVariable(ControlFlowVariable value);

	/**
	 * Returns the value of the '<em><b>Resource Demand</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource Demand</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource Demand</em>' reference.
	 * @see #setResourceDemand(ResourceDemand)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getInfluencedVariableReference_ResourceDemand()
	 * @model
	 * @generated
	 */
	ResourceDemand getResourceDemand();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResourceDemand <em>Resource Demand</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resource Demand</em>' reference.
	 * @see #getResourceDemand()
	 * @generated
	 */
	void setResourceDemand(ResourceDemand value);

	/**
	 * Returns the value of the '<em><b>Response Time</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Response Time</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Response Time</em>' reference.
	 * @see #setResponseTime(ResponseTime)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getInfluencedVariableReference_ResponseTime()
	 * @model
	 * @generated
	 */
	ResponseTime getResponseTime();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResponseTime <em>Response Time</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Response Time</em>' reference.
	 * @see #getResponseTime()
	 * @generated
	 */
	void setResponseTime(ResponseTime value);

} // InfluencedVariableReference
