/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.deployment.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.deployment.Deployment;
import edu.kit.ipd.descartes.mm.deployment.DeploymentContext;
import edu.kit.ipd.descartes.mm.deployment.DeploymentPackage;

import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Deployment</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl#getSystem <em>System</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl#getTargetResourceLandscape <em>Target Resource Landscape</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl#getDeploymentContexts <em>Deployment Contexts</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeploymentImpl extends EntityImpl implements Deployment {
	/**
	 * The cached value of the '{@link #getSystem() <em>System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSystem()
	 * @generated
	 * @ordered
	 */
	protected edu.kit.ipd.descartes.mm.applicationlevel.system.System system;

	/**
	 * The cached value of the '{@link #getTargetResourceLandscape() <em>Target Resource Landscape</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetResourceLandscape()
	 * @generated
	 * @ordered
	 */
	protected DistributedDataCenter targetResourceLandscape;

	/**
	 * The cached value of the '{@link #getDeploymentContexts() <em>Deployment Contexts</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeploymentContexts()
	 * @generated
	 * @ordered
	 */
	protected EList<DeploymentContext> deploymentContexts;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeploymentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DeploymentPackage.Literals.DEPLOYMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public edu.kit.ipd.descartes.mm.applicationlevel.system.System getSystem() {
		if (system != null && system.eIsProxy()) {
			InternalEObject oldSystem = (InternalEObject)system;
			system = (edu.kit.ipd.descartes.mm.applicationlevel.system.System)eResolveProxy(oldSystem);
			if (system != oldSystem) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DeploymentPackage.DEPLOYMENT__SYSTEM, oldSystem, system));
			}
		}
		return system;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public edu.kit.ipd.descartes.mm.applicationlevel.system.System basicGetSystem() {
		return system;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSystem(edu.kit.ipd.descartes.mm.applicationlevel.system.System newSystem) {
		edu.kit.ipd.descartes.mm.applicationlevel.system.System oldSystem = system;
		system = newSystem;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DeploymentPackage.DEPLOYMENT__SYSTEM, oldSystem, system));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DistributedDataCenter getTargetResourceLandscape() {
		if (targetResourceLandscape != null && targetResourceLandscape.eIsProxy()) {
			InternalEObject oldTargetResourceLandscape = (InternalEObject)targetResourceLandscape;
			targetResourceLandscape = (DistributedDataCenter)eResolveProxy(oldTargetResourceLandscape);
			if (targetResourceLandscape != oldTargetResourceLandscape) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE, oldTargetResourceLandscape, targetResourceLandscape));
			}
		}
		return targetResourceLandscape;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DistributedDataCenter basicGetTargetResourceLandscape() {
		return targetResourceLandscape;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTargetResourceLandscape(DistributedDataCenter newTargetResourceLandscape) {
		DistributedDataCenter oldTargetResourceLandscape = targetResourceLandscape;
		targetResourceLandscape = newTargetResourceLandscape;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE, oldTargetResourceLandscape, targetResourceLandscape));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DeploymentContext> getDeploymentContexts() {
		if (deploymentContexts == null) {
			deploymentContexts = new EObjectContainmentWithInverseEList<DeploymentContext>(DeploymentContext.class, this, DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS, DeploymentPackage.DEPLOYMENT_CONTEXT__DEPLOYMENT);
		}
		return deploymentContexts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getDeploymentContexts()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				return ((InternalEList<?>)getDeploymentContexts()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__SYSTEM:
				if (resolve) return getSystem();
				return basicGetSystem();
			case DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE:
				if (resolve) return getTargetResourceLandscape();
				return basicGetTargetResourceLandscape();
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				return getDeploymentContexts();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__SYSTEM:
				setSystem((edu.kit.ipd.descartes.mm.applicationlevel.system.System)newValue);
				return;
			case DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE:
				setTargetResourceLandscape((DistributedDataCenter)newValue);
				return;
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				getDeploymentContexts().clear();
				getDeploymentContexts().addAll((Collection<? extends DeploymentContext>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__SYSTEM:
				setSystem((edu.kit.ipd.descartes.mm.applicationlevel.system.System)null);
				return;
			case DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE:
				setTargetResourceLandscape((DistributedDataCenter)null);
				return;
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				getDeploymentContexts().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DeploymentPackage.DEPLOYMENT__SYSTEM:
				return system != null;
			case DeploymentPackage.DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE:
				return targetResourceLandscape != null;
			case DeploymentPackage.DEPLOYMENT__DEPLOYMENT_CONTEXTS:
				return deploymentContexts != null && !deploymentContexts.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //DeploymentImpl
