/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.predictionset;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import deployment_0='../../edu.kit.ipd.descartes.mm.deployment/model/deployment.ecore#/' ecore_0='http://www.eclipse.org/emf/2002/Ecore' probes_0='../../edu.kit.ipd.descartes.solving.probes/model/probes.ecore#/' repository_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/repository.ecore#/' resourcelandscape_0='../../edu.kit.ipd.descartes.mm.resourcelandscape/model/resourcelandscape.ecore#/' system_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/system.ecore#/' usageprofile_0='../../edu.kit.ipd.descartes.mm.usageprofile/model/usageprofile.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface PredictionSetPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "predictionset";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/predictionset/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "predictionset";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PredictionSetPackage eINSTANCE = edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetImpl <em>Prediction Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetImpl
	 * @see edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetPackageImpl#getPredictionSet()
	 * @generated
	 */
	int PREDICTION_SET = 0;

	/**
	 * The feature id for the '<em><b>Usageprofile Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET__USAGEPROFILE_MODEL = 0;

	/**
	 * The feature id for the '<em><b>Deployment Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET__DEPLOYMENT_MODEL = 1;

	/**
	 * The feature id for the '<em><b>System Model</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET__SYSTEM_MODEL = 2;

	/**
	 * The feature id for the '<em><b>Repository Model</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET__REPOSITORY_MODEL = 3;

	/**
	 * The feature id for the '<em><b>Resourcelandscape Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET__RESOURCELANDSCAPE_MODEL = 4;

	/**
	 * The number of structural features of the '<em>Prediction Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICTION_SET_FEATURE_COUNT = 5;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet <em>Prediction Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prediction Set</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet
	 * @generated
	 */
	EClass getPredictionSet();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getUsageprofileModel <em>Usageprofile Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Usageprofile Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getUsageprofileModel()
	 * @see #getPredictionSet()
	 * @generated
	 */
	EReference getPredictionSet_UsageprofileModel();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getDeploymentModel <em>Deployment Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deployment Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getDeploymentModel()
	 * @see #getPredictionSet()
	 * @generated
	 */
	EReference getPredictionSet_DeploymentModel();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getSystemModel <em>System Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>System Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getSystemModel()
	 * @see #getPredictionSet()
	 * @generated
	 */
	EReference getPredictionSet_SystemModel();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getRepositoryModel <em>Repository Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Repository Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getRepositoryModel()
	 * @see #getPredictionSet()
	 * @generated
	 */
	EReference getPredictionSet_RepositoryModel();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getResourcelandscapeModel <em>Resourcelandscape Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Resourcelandscape Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getResourcelandscapeModel()
	 * @see #getPredictionSet()
	 * @generated
	 */
	EReference getPredictionSet_ResourcelandscapeModel();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PredictionSetFactory getPredictionSetFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetImpl <em>Prediction Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetImpl
		 * @see edu.kit.ipd.descartes.mm.predictionset.impl.PredictionSetPackageImpl#getPredictionSet()
		 * @generated
		 */
		EClass PREDICTION_SET = eINSTANCE.getPredictionSet();

		/**
		 * The meta object literal for the '<em><b>Usageprofile Model</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICTION_SET__USAGEPROFILE_MODEL = eINSTANCE.getPredictionSet_UsageprofileModel();

		/**
		 * The meta object literal for the '<em><b>Deployment Model</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICTION_SET__DEPLOYMENT_MODEL = eINSTANCE.getPredictionSet_DeploymentModel();

		/**
		 * The meta object literal for the '<em><b>System Model</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICTION_SET__SYSTEM_MODEL = eINSTANCE.getPredictionSet_SystemModel();

		/**
		 * The meta object literal for the '<em><b>Repository Model</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICTION_SET__REPOSITORY_MODEL = eINSTANCE.getPredictionSet_RepositoryModel();

		/**
		 * The meta object literal for the '<em><b>Resourcelandscape Model</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICTION_SET__RESOURCELANDSCAPE_MODEL = eINSTANCE.getPredictionSet_ResourcelandscapeModel();

	}

} //PredictionSetPackage
