/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.predictionset.util;

import edu.kit.ipd.descartes.mm.predictionset.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage
 * @generated
 */
public class PredictionSetValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final PredictionSetValidator INSTANCE = new PredictionSetValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.predictionset";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredictionSetValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return PredictionSetPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case PredictionSetPackage.PREDICTION_SET:
				return validatePredictionSet((PredictionSet)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePredictionSet(PredictionSet predictionSet, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(predictionSet, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(predictionSet, diagnostics, context);
		if (result || diagnostics != null) result &= validatePredictionSet_SystemModelReferencedByDeploymentModelAndUsageProfileModelMustBeTheSame(predictionSet, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SystemModelReferencedByDeploymentModelAndUsageProfileModelMustBeTheSame constraint of '<em>Prediction Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String PREDICTION_SET__SYSTEM_MODEL_REFERENCED_BY_DEPLOYMENT_MODEL_AND_USAGE_PROFILE_MODEL_MUST_BE_THE_SAME__EEXPRESSION = "\n" +
		"\t\t\tsystemModel = deploymentModel.system";

	/**
	 * Validates the SystemModelReferencedByDeploymentModelAndUsageProfileModelMustBeTheSame constraint of '<em>Prediction Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePredictionSet_SystemModelReferencedByDeploymentModelAndUsageProfileModelMustBeTheSame(PredictionSet predictionSet, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(PredictionSetPackage.Literals.PREDICTION_SET,
				 predictionSet,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SystemModelReferencedByDeploymentModelAndUsageProfileModelMustBeTheSame",
				 PREDICTION_SET__SYSTEM_MODEL_REFERENCED_BY_DEPLOYMENT_MODEL_AND_USAGE_PROFILE_MODEL_MUST_BE_THE_SAME__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //PredictionSetValidator
