/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.mm.usageprofile.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class UsageProfileFactoryImpl extends EFactoryImpl implements UsageProfileFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static UsageProfileFactory init() {
		try {
			UsageProfileFactory theUsageProfileFactory = (UsageProfileFactory)EPackage.Registry.INSTANCE.getEFactory(UsageProfilePackage.eNS_URI);
			if (theUsageProfileFactory != null) {
				return theUsageProfileFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new UsageProfileFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageProfileFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case UsageProfilePackage.USAGE_PROFILE: return createUsageProfile();
			case UsageProfilePackage.USAGE_SCENARIO: return createUsageScenario();
			case UsageProfilePackage.SCENARIO_BEHAVIOR: return createScenarioBehavior();
			case UsageProfilePackage.IMPORT: return createImport();
			case UsageProfilePackage.OPEN_WORKLOAD_TYPE: return createOpenWorkloadType();
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE: return createClosedWorkloadType();
			case UsageProfilePackage.LOOP_USER_ACTION: return createLoopUserAction();
			case UsageProfilePackage.DELAY_USER_ACTION: return createDelayUserAction();
			case UsageProfilePackage.BRANCH_USER_ACTION: return createBranchUserAction();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION: return createSystemCallUserAction();
			case UsageProfilePackage.CALL_PARAMETER_SETTING: return createCallParameterSetting();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageProfile createUsageProfile() {
		UsageProfileImpl usageProfile = new UsageProfileImpl();
		return usageProfile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageScenario createUsageScenario() {
		UsageScenarioImpl usageScenario = new UsageScenarioImpl();
		return usageScenario;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScenarioBehavior createScenarioBehavior() {
		ScenarioBehaviorImpl scenarioBehavior = new ScenarioBehaviorImpl();
		return scenarioBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Import createImport() {
		ImportImpl import_ = new ImportImpl();
		return import_;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OpenWorkloadType createOpenWorkloadType() {
		OpenWorkloadTypeImpl openWorkloadType = new OpenWorkloadTypeImpl();
		return openWorkloadType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClosedWorkloadType createClosedWorkloadType() {
		ClosedWorkloadTypeImpl closedWorkloadType = new ClosedWorkloadTypeImpl();
		return closedWorkloadType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopUserAction createLoopUserAction() {
		LoopUserActionImpl loopUserAction = new LoopUserActionImpl();
		return loopUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DelayUserAction createDelayUserAction() {
		DelayUserActionImpl delayUserAction = new DelayUserActionImpl();
		return delayUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BranchUserAction createBranchUserAction() {
		BranchUserActionImpl branchUserAction = new BranchUserActionImpl();
		return branchUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SystemCallUserAction createSystemCallUserAction() {
		SystemCallUserActionImpl systemCallUserAction = new SystemCallUserActionImpl();
		return systemCallUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallParameterSetting createCallParameterSetting() {
		CallParameterSettingImpl callParameterSetting = new CallParameterSettingImpl();
		return callParameterSetting;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageProfilePackage getUsageProfilePackage() {
		return (UsageProfilePackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static UsageProfilePackage getPackage() {
		return UsageProfilePackage.eINSTANCE;
	}

} //UsageProfileFactoryImpl
